#ifndef _PLATFORM_SPECIFIC_H_
#define _PLATFORM_SPECIFIC_H_

#define _CRT_SECURE_NO_WARNINGS
#define CRT_SECURE_NO_WARNINGS

#if defined( __LP64__ ) || defined( _LINUX_X64 ) || !defined( _WIN32 )
#include <stdint.h>
#endif

//Some parameter types to allow for x64
#ifdef _WIN32
	// Windows
	#include <basetsd.h> //For all the x64 stuff.
#ifdef _WIN64
	// x64
	//typedef INT_PTR VENSIM_LONG ;
	#define VENSIM_UNSIGNED_LONG			INT_PTR
	#define VENSIM_LONG						INT_PTR
	#define VENSIM_INT						INT_PTR
	#define VENSIM_MEM_SIZE_REQUIRED_BYTES	INT_PTR
	#define VENSIM_MEM_BLOCK_PTR			INT_PTR
	#define DBLPREC
#else // not _WIN64
	// We're on x86 (or perhaps IA64, but that one doesn't matter anymore). Yay!
	#define VENSIM_UNSIGNED_LONG			unsigned long
	#define VENSIM_LONG						long
	#define VENSIM_INT						int
	#define VENSIM_MEM_SIZE_REQUIRED_BYTES	V4BYTEU
	#define VENSIM_MEM_BLOCK_PTR			V4BYTEU
#endif // end _WIN64

#else // not _WIN32
	// We're not on Windows
#if defined( __LP64__ ) || defined( _LINUX_X64 ) // mac/linux x64
    #define _WIN64
	typedef int64_t INT_PTR;
	#define VENSIM_UNSIGNED_LONG			INT_PTR
	#define VENSIM_LONG						INT_PTR
	#define VENSIM_INT						INT_PTR
	#define VENSIM_MEM_SIZE_REQUIRED_BYTES	INT_PTR
	#define VENSIM_MEM_BLOCK_PTR			INT_PTR
    #ifndef min
       #define min(a,b) ((a)<(b)?(a):(b))
    #endif
    #define _lseeki64 lseek64
	#define DBLPREC
#else // must be 32 bit mac or linux
    #define VENSIM_LONG                                           long
    #define VENSIM_MEM_SIZE_REQUIRED_BYTES    V4BYTEU
    #define VENSIM_MEM_BLOCK_PTR                       V4BYTEU
	#ifdef _MACX
	#define INT_MAX 32767
	#endif
#endif

#endif

#ifdef _WIN64
#define VBITVERSION   "x64"
#define _VDFX
#else
#define VBITVERSION   "x32"
#endif

#endif //_PLATFORM_SPECIFIC_H_
